﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace MirrorMatch
{
	abstract class Entity
	{
        public Vector2 Position { get; set; }
        public float Orientation { get; set; }

        protected Entity()
        {
            Position = new Vector2(0, 0);
            Orientation = 0;
        }

        public virtual RayIntersection intersects(Ray ray) { return null; }
        public virtual void onIntersection(LaserRay ray, RayIntersection intersection) {}

        public abstract Vector2[] getBoundingVolume();
        public abstract void Draw(SpriteBatch spriteBatch);

	}
}