﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace MirrorMatch
{
    class Wall : Entity
    {
        private IShape shape;

        public Wall(IShape shape)
        {
            this.shape = shape;
            shape.texturize(ResourceManager.Instance.GetTexture("wall"));
        }

        override public void Draw(SpriteBatch spriteBatch)
        {
            shape.draw(spriteBatch);
        }

        public override RayIntersection intersects(Ray ray)
        {
            RayIntersection intersection = shape.intersects(ray);
            if (intersection != null)
                intersection.IntersectingEntity = this;
            return intersection;
        }

        public override void onIntersection(LaserRay ray, RayIntersection intersection)
        {
            //do nothing
        }

        public override Vector2[] getBoundingVolume()
        {
            return shape.getBoundingVolume();
        }
    }
}
