﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace MirrorMatch
{
	class GameObjectManager
	{
        private static GameObjectManager instance;
        private List<Entity> staticEntities;
        private List<Entity> dynamicEntities;
        private KdTree staticTree;

		private GameObjectManager()
        {
            staticEntities = new List<Entity>();
            dynamicEntities = new List<Entity>();
		}

		public static GameObjectManager GetInstance()
		{
			if (instance == null)
			{
				instance = new GameObjectManager();
			}
			return instance;
		}

        public KdTree StaticTree
        {
            get
            {
                return staticTree;
            }
        }

		public List<Entity> StaticEntities
		{
			get
			{
				return staticEntities;
			}
		}

        public List<Entity> DynamicEntities
        {
            get
            {
                return dynamicEntities;
            }
        }

        public void initStaticTree(Vector2 min, Vector2 max)
        {
            staticTree = KdTree.generate(min, max, 7, true);
        }

		public void setStaticEntities(List<Entity> ent)
		{
			staticEntities = ent;
            foreach (Entity entity in staticEntities)
            {
                staticTree.addEntity(entity);
            }
		}
	}
}
