﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace MirrorMatch
{
    class QuadTree
    {
        Vector2 min, max;
        QuadTree[] children = new QuadTree[4];
        List<Entity> entities;

        static QuadTree generate(Vector2 min, Vector2 max, int depth)
        {
            if (depth <= 0)
                return null;

            QuadTree node = new QuadTree(min, max);

            Vector2 mid = (min+max)/2;

            node.children[0] = generate(new Vector2(min.X, min.Y), new Vector2(mid.X, mid.Y), depth - 1);
            node.children[1] = generate(new Vector2(mid.X, min.Y), new Vector2(max.X, mid.Y), depth - 1);
            node.children[2] = generate(new Vector2(min.X, mid.Y), new Vector2(mid.X, max.Y), depth - 1);
            node.children[3] = generate(new Vector2(mid.X, mid.Y), new Vector2(max.X, max.Y), depth - 1);

            return node;
        }

        //bool addEntity(Entity entity)
        //{

        //}

        public QuadTree(Vector2 min, Vector2 max)
        {
            this.min = min;
            this.max = max;

            for (int i = 0; i < 4; i++)
            {
                children[i] = null;
            }

            entities = new List<Entity>();
        }
    }
}
