﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace MirrorMatch
{
	class TailPoint
	{
		public Vector2 Position { get; set; }
		public TailPoint Parent { get; set; }
		public Vector2 ParentPosition {
			get {
				if(Parent != null)
					return Parent.Position;
				return Vector2.Zero;
			}
		}
		public Color color { get; set; }
		//public Vector2 Direction { get; set; }

		public TailPoint()
		{
			this.Position = Vector2.Zero;
			this.Parent = null;
			color = Color.Black;
		}

		public TailPoint(Vector2 position, TailPoint parent)
		{
			this.Position = position;
			this.Parent = parent;
			color = Color.Black;
		}

		public float Radian
		{
			get
			{
				float angle = (float)(Math.Atan2(Parent.Position.Y - Position.Y, Parent.Position.X - Position.X));
				return angle;
			}
		}
	}
}
