﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace MirrorMatch
{
	class Connection
	{
		private bool hasConnection;
		private List<string> messageList;
		private TcpListener tcpListener;
		private Thread listenThread;
		private Thread clientThread;
		private TcpClient client;
        private string latestMessage;
        private NetworkStream networkStream;
        private StreamReader streamReader;

		public Connection(int port)
		{
			hasConnection = false;
			messageList = new List<string>();
			this.client = null;
			this.tcpListener = new TcpListener(IPAddress.Any, port);
			this.listenThread = new Thread(new ThreadStart(ListenForClients));
			this.listenThread.Start();
		}

		private void ListenForClients()
		{
			try
			{
				this.tcpListener.Start();

				while (!hasConnection)
				{
					//blocks until a client has connected to the server
					client = tcpListener.AcceptTcpClient();
					hasConnection = true;
				}

                //init the network reading streams
                networkStream = client.GetStream();
                streamReader = new StreamReader(networkStream);
			}
			catch
			{ }
		}

        byte[] buffer = new byte[1024 * 8];
		public string ReadMessage()
		{
            string message = null;

			try
			{
                if(networkStream.DataAvailable)
                {
                    //read normally blocks until a client sends a message, but we only read if data is available, thus avoiding blocks
                    //int bytesRead = networkStream.Read(buffer, 0, buffer.Length);
                    //message = encoder.GetString(buffer, 0, bytesRead);
                    message = streamReader.ReadLine();
				    if (message == "")
				    {
                        message = null;
				    }
                }
			}
			catch
			{ }

            return message;
		}

		public void Cleanup()
		{
            hasConnection = false;
            if (listenThread != null)
                listenThread.Abort();
            if (clientThread != null)
                clientThread.Abort();
            if (tcpListener != null)
                tcpListener.Stop();
            if (client != null)
                client.Close();
		}

		public string getMessage()
		{
			string tmpMessage = this.latestMessage;
			latestMessage = "";
			return tmpMessage;
		}

		public bool hasMessage()
		{
			if (latestMessage != null && latestMessage != "")
				return true;
			return false;
		}

		public bool isConnected()
		{
			return this.hasConnection;
		}

		public TcpClient getClient()
		{
			return client;
		}
	}
}
