﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Xml;
using System.Threading;

namespace MirrorMatch
{
	class CreateGameState: State
	{
		private Connection connection;
		private TcpClient tcpClient;
		private Level level;
        private Cursor cursor;
        private bool cleanupConnection = true;

		public CreateGameState()
		{
			this.level = ResourceManager.Instance.GetLevel("CircleArena");
			connection = new Connection(1337);
			tcpClient = null;
            cursor = new Cursor();
		}

		public override void LoadContent()
		{
            cursor.LoadContent();
		}

		public override void  Update(Microsoft.Xna.Framework.GameTime gameTime)
		{
			if (Keyboard.GetState().IsKeyDown(Keys.Escape))
			{
				connection.Cleanup();
				NextState = new MainMenuState();
			}

			if (this.connection.isConnected())
			{
				// Connect to the connected client
				string ip = connection.getClient().Client.RemoteEndPoint.ToString();
				ip = ip.Substring(0, ip.IndexOf(':'));
				tcpClient = new TcpClient(ip, 1337);
                cleanupConnection = false;
				NextState = new InMultiplayerGameState(tcpClient, connection, level, "Master");
			}
		}

		public override void  Draw(Microsoft.Xna.Framework.GameTime gameTime, Microsoft.Xna.Framework.Graphics.SpriteBatch spriteBatch)
		{
			spriteBatch.DrawString(ResourceManager.Instance.GetFont("arial"), "Waiting for other player...",
					new Vector2(MirrorMatch.Instance.WindowWidth / 2f - 100f, MirrorMatch.Instance.WindowHeight / 2f - 50f),
					Color.CornflowerBlue);
            cursor.Draw(gameTime, spriteBatch);
		}

		public override void  Cleanup()
		{
            if (cleanupConnection)
                connection.Cleanup();
		}
	}
}