﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using System.IO;
using System.Net;
using System.Net.Sockets;

namespace MirrorMatch
{
	class JoinGameState : State
	{
		//private Keys lastKey;
		private Level level;
        private XnaTextField ipTextField, idTextField;
        private Cursor cursor;
		private Connection connection;
        private bool cleanupConnection = true;

		public JoinGameState()
		{
			this.level = ResourceManager.Instance.GetLevel("CircleArena");
            cursor = new Cursor();
		}

		public override void LoadContent()
		{
            cursor.LoadContent();
            ipTextField = new XnaTextField("Fonts/arial", MirrorMatch.Instance.Content, MirrorMatch.Instance.GraphicsDevice);
            ipTextField.SetPosition(100, 100);
            ipTextField.SetText("192.168.1.99");
            ipTextField.IsActive = false;
            idTextField = new XnaTextField("Fonts/arial", MirrorMatch.Instance.Content, MirrorMatch.Instance.GraphicsDevice);
            idTextField.SetPosition(100, 200);
            idTextField.SetText("Player name");
            idTextField.IsActive = false;
		}

		public override void Update(GameTime gameTime)
		{
            KeyboardState keyboard = Keyboard.GetState();
            MouseState mouse = Mouse.GetState();
            Point mousePosition = new Point(mouse.X, mouse.Y);

            // Activate text field on click and ensure only one can be active at a given time
            if (ipTextField.GetBounds().Contains(mousePosition) && mouse.LeftButton == ButtonState.Pressed)
            {
                ipTextField.IsActive = true;
                idTextField.IsActive = false;
            }
            if (idTextField.GetBounds().Contains(mousePosition) && mouse.LeftButton == ButtonState.Pressed)
            {
                ipTextField.IsActive = false;
                idTextField.IsActive = true;
            }

            // Update text fields
            ipTextField.Update(gameTime);
            idTextField.Update(gameTime);

            // Enter initiate the connection
            if (keyboard.IsKeyDown(Keys.Enter))
            {
                connection = new Connection(1337);
                TcpClient tcpClient = new TcpClient(ipTextField.GetText(), 1337);
                IPHostEntry iphostentry = Dns.GetHostEntry(Dns.GetHostName());
                cleanupConnection = false;
				NextState = new InMultiplayerGameState(tcpClient, connection, level, idTextField.GetText());
				NextState = new InMultiplayerGameState(tcpClient, connection, level, "Slave");
            }
			if (keyboard.IsKeyDown(Keys.Escape))
			{
				if(connection != null)
					connection.Cleanup();
				NextState = new MainMenuState();
			}

            #region Old Input
            //Keys[] pressed_Key = Keyboard.GetState().GetPressedKeys();
            //if (lastKey == 0)
            //{
            //    for (int i = 0; i < pressed_Key.Length; i++)
            //    {
            //        switch (pressed_Key[i])
            //        {
            //            case Keys.Escape:
            //                Cleanup();
            //                NextState = new MainMenuState();
            //                break;
            //            case Keys.NumPad0:
            //                ipAddress += "0";
            //                break;
            //            case Keys.NumPad1:
            //                ipAddress += "1";
            //                break;
            //            case Keys.NumPad2:
            //                ipAddress += "2";
            //                break;
            //            case Keys.NumPad3:
            //                ipAddress += "3";
            //                break;
            //            case Keys.NumPad4:
            //                ipAddress += "4";
            //                break;
            //            case Keys.NumPad5:
            //                ipAddress += "5";
            //                break;
            //            case Keys.NumPad6:
            //                ipAddress += "6";
            //                break;
            //            case Keys.NumPad7:
            //                ipAddress += "7";
            //                break;
            //            case Keys.NumPad8:
            //                ipAddress += "8";
            //                break;
            //            case Keys.NumPad9:
            //                ipAddress += "9";
            //                break;
            //            case Keys.D0:
            //                ipAddress += "0";
            //                break;
            //            case Keys.D1:
            //                ipAddress += "1";
            //                break;
            //            case Keys.D2:
            //                ipAddress += "2";
            //                break;
            //            case Keys.D3:
            //                ipAddress += "3";
            //                break;
            //            case Keys.D4:
            //                ipAddress += "4";
            //                break;
            //            case Keys.D5:
            //                ipAddress += "5";
            //                break;
            //            case Keys.D6:
            //                ipAddress += "6";
            //                break;
            //            case Keys.D7:
            //                ipAddress += "7";
            //                break;
            //            case Keys.D8:
            //                ipAddress += "8";
            //                break;
            //            case Keys.D9:
            //                ipAddress += "9";
            //                break;
            //            case Keys.OemPeriod:
            //                ipAddress += ".";
            //                break;
            //            case Keys.Back:
            //                if(ipAddress.Length > 0)
            //                    ipAddress = ipAddress.Substring(0, ipAddress.Length - 1);
            //                break;
            //            case Keys.L:
            //                ipAddress = "localhost";
            //                break;
            //            case Keys.J:
            //                ipAddress = "5.107.37.149";
            //                break;
            //            case Keys.R:
            //                ipAddress = "5.90.189.69";
            //                break;
            //            case Keys.Enter:
            //                tcpClient = new TcpClient(ipAddress, 1337);
            //                IPHostEntry iphostentry = Dns.GetHostEntry(Dns.GetHostName());
            //                string myIp = "";
            //                foreach (IPAddress address in iphostentry.AddressList)
            //                {
            //                    if(address.ToString().Substring(0, 2) == "5.")
            //                        myIp = address.ToString();
            //                }
            //                string str = "<connect ip='" + myIp + "'></connect>";

            //                NetworkStream clientStream = tcpClient.GetStream();
            //                ASCIIEncoding encoder = new ASCIIEncoding();
            //                byte[] buffer = encoder.GetBytes(str);

            //                clientStream.Write(buffer, 0, buffer.Length);
            //                clientStream.Flush();

            //                NextState = new InMultiplayerGameState(tcpClient, connection, level);
            //                break;
            //            default:
            //                break;
            //        }
            //        lastKey = pressed_Key[i];
            //    }
            
            //}
            //else
            //{
            //    if (Keyboard.GetState().IsKeyUp(lastKey))
            //    {
            //        lastKey = 0;
            //    }
            //}
            #endregion
		}

		public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
		{
			spriteBatch.DrawString(ResourceManager.Instance.GetFont("arial"), "Input IP and player name in the text boxes. Press ENTER when done.", Vector2.Zero, Color.CornflowerBlue);
            ipTextField.Draw(spriteBatch);
            idTextField.Draw(spriteBatch);
            cursor.Draw(gameTime, spriteBatch);
		}

		public override void Cleanup()
        {
            if (cleanupConnection && connection != null)
                connection.Cleanup();
		}
	}
}
