﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Xml;
using System.Threading;

namespace MirrorMatch
{
    class GameOverState : State
    {
        
        //TcpClient client;
        //Connection connection;
        //Level level;
        //string localPlayerId;
        ScoreData scoreData;

        Cursor cursor;
        //MenuButton reMatchButton;
        MenuButton backToMainButton;

        public GameOverState(ScoreData scoreData /*, TcpClient client, Connection connection, Level level, string localPlayerId*/)
        {
            //this.client = client;
            //this.connection = connection;
            //this.level = level;
            //this.localPlayerId = localPlayerId;
            this.scoreData = scoreData;

            // General button settings
            SpriteFont buttonFont = ResourceManager.Instance.GetFont("arial");
            Color buttonColor = new Color(0, 130, 255);
            Color textColor = Color.White;
            string buttonText = "";
            Rectangle buttonBounds;

            //// Re-Match button button
            //buttonText = "Re-Match!";
            //buttonBounds = new Rectangle(
            //    200,
            //    (int)(MirrorMatch.Instance.WindowHeight - 100),
            //    110,
            //    50);
            //reMatchButton = new MenuButton(buttonText, buttonFont, textColor, buttonColor, buttonBounds);

            // Back to main button
            buttonText = "Back to Main";
            buttonBounds = new Rectangle(
                (int)(MirrorMatch.Instance.WindowHeight - 200),
                (int)(MirrorMatch.Instance.WindowHeight - 100),
                110,
                50);
            backToMainButton = new MenuButton(buttonText, buttonFont, textColor, buttonColor, buttonBounds);
			Thread.Sleep(500);
            
            cursor = new Cursor();
        }
        public override void LoadContent()
        {
			cursor.LoadContent();
        }
        public override void Update(GameTime gameTime)
        {
            //// Re-match button
            //if (reMatchButton.ButtonClicked)
            //    NextState = new InMultiplayerGameState(client, connection, level, localPlayerId);
            //if (reMatchButton.IsHoveredOver)
            //    reMatchButton.TextColor = Color.Red;
            //else
            //    reMatchButton.TextColor = Color.CornflowerBlue;

            // Return to Main button
            if (backToMainButton.ButtonClicked)
                NextState = new MainMenuState();
            if (backToMainButton.IsHoveredOver)
                backToMainButton.TextColor = Color.Red;
            else
                backToMainButton.TextColor = Color.White;
        }
        public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            SpriteFont font = ResourceManager.Instance.GetFont("arial");
            spriteBatch.DrawString(font, 
                "SCORE BOARD:\n"+scoreData.ScoreBoardAsString+"\n"
                /*+"KILL BOARD:\n"+scoreData.VictoryBoard*/ ,
                new Vector2(200, 200), Color.CornflowerBlue);

            //reMatchButton.Draw(gameTime, spriteBatch);
            backToMainButton.Draw(gameTime, spriteBatch);
            cursor.Draw(gameTime, spriteBatch);
        }
        public override void Cleanup()
        {
        }
    }
}
