﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace MirrorMatch
{
    abstract class InGameController
    {
        public abstract bool MoveUp();
        public abstract bool MoveDown();
        public abstract bool MoveLeft();
        public abstract bool MoveRight();
        public abstract bool Fire();
        /// <summary>
        /// Calculate the direction an entity is aiming in when aiming at the current mouse location.
        /// </summary>
        /// <param name="position">Position in svg space to aim from</param>
        /// <returns>A vector indicating aim direction in svg space</returns>
        public abstract Vector2 AimDirection(Vector2 position);
    }
}
