﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace MirrorMatch
{
	class StateManager
	{
		State activeState;

		public StateManager(State initialState)
		{
			activeState = initialState;
		}
		public void LoadContent()
		{
			activeState.LoadContent();
		}
        public void Update(GameTime gameTime)
		{
			if (activeState.NextState != null)
			{
                activeState.Cleanup();
                activeState = activeState.NextState;
				activeState.LoadContent();
			}
			activeState.Update(gameTime);
		}
        public void Draw(GameTime gameTime, SpriteBatch spriteBatch)
		{
			activeState.Draw(gameTime, spriteBatch);
		}
		public void Cleanup()
		{
			activeState.Cleanup();
		}
	}
}